#region Copyright Syncfusion Inc. 2001 - 2017
// Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion

namespace PivotGridCustomization.Action
{
    using System.Linq;
    using System.Windows.Interactivity;
    using Syncfusion.Windows.Controls.PivotGrid;
    using System.Windows;
    using System.Windows.Controls;
    using System.Windows.Media;
    class SubtotalVisibilityChangedAction : TargetedTriggerAction<Grid>
    {
        static int count = 0;
        protected override void Invoke(object parameter)
        {
            RoutedEventArgs eventArgs = parameter as RoutedEventArgs;
            CheckBox current = eventArgs.OriginalSource as CheckBox;
            PivotGridControl pivot = this.Target.Children[2] as PivotGridControl;
            TabControl TabControlExt = VisualTreeHelper.GetChild(Target, 3) as TabControl;
            GroupBox subtotalGroupBox = TabControlExt.FindName("ShowSubTotalGroupBox") as GroupBox;
            CheckBox showAllSubTotals = (subtotalGroupBox as GroupBox).FindName("chkShowSubTotals") as CheckBox;
            CheckBox showProductSubTotals = (subtotalGroupBox as GroupBox).FindName("chkShowProductSubTotals") as CheckBox;
            CheckBox showDateSubTotals = (subtotalGroupBox as GroupBox).FindName("chkShowDateSubTotals") as CheckBox;
            CheckBox showCountrySubTotals = (subtotalGroupBox as GroupBox).FindName("chkShowCountrySubTotals") as CheckBox;
            CheckBox showStateSubTotals = (subtotalGroupBox as GroupBox).FindName("chkShowStateSubTotals") as CheckBox;
            CheckBox showRowSubTotals = (subtotalGroupBox as GroupBox).FindName("chkShowRowSubTotals") as CheckBox;
            CheckBox showColumnSubTotals = (subtotalGroupBox as GroupBox).FindName("chkShowColumnSubTotals") as CheckBox;

            int index = 0;
            switch (current.Content.ToString())
            {
                case "Show Product Subtotals":

                    if (current.IsChecked == true)
                    {
                        if (pivot.PivotCalculations.Any(i => i.FieldName == "Product"))
                        {
                            pivot.ShowSubTotals = true;
                            count--;
                        }
                        if (pivot.GroupingBar.Filters.Any(i => i.Name == "Product"))
                        {
                            index = pivot.GroupingBar.Filters.IndexOf(pivot.GroupingBar.Filters.FirstOrDefault(x => x.Name == "Product"));
                            if (index >= 0)
                            {
                                pivot.ShowSubTotals = true;
                                pivot.GroupingBar.Filters[index].ShowSubTotal = true;
                                count--;
                            }
                        }  
                        index = pivot.PivotRows.IndexOf(pivot.PivotRows.FirstOrDefault(x => x.FieldMappingName == "Product"));
                        if (index >= 0)
                        {
                            pivot.ShowSubTotals = true;
                            pivot.PivotRows[index].ShowSubTotal = true;
                            count--;
                        }
                        else
                        {
                            index = pivot.PivotColumns.IndexOf(pivot.PivotColumns.FirstOrDefault(x => x.FieldMappingName == "Product"));
                            if (index >= 0)
                            {
                                pivot.ShowSubTotals = true;
                                pivot.PivotColumns[index].ShowSubTotal = true;
                                count--;
                            }
                        }
                    }
                    else
                    {
                        index = pivot.PivotRows.IndexOf(pivot.PivotRows.FirstOrDefault(x => x.FieldMappingName == "Product"));
                        if (index >= 0)
                        {
                            pivot.PivotRows[index].ShowSubTotal = false;
                            count++;
                        }
                        else
                        {
                            index = pivot.PivotColumns.IndexOf(pivot.PivotColumns.FirstOrDefault(x => x.FieldMappingName == "Product"));
                            if (index >= 0)
                            {
                                pivot.PivotColumns[index].ShowSubTotal = false;
                                count++;
                            }
                        }
                    }
                    pivot.InvalidateCells();

                    break;
                case "Show Country Subtotals":
                    if (current.IsChecked == true)
                    {
                        if (pivot.PivotCalculations.Any(i => i.FieldName == "Country"))
                        {
                            pivot.ShowSubTotals = true;
                            count--;
                        }
                        if (pivot.GroupingBar.Filters.Any(i => i.Name == "Country"))
                        {
                            index = pivot.GroupingBar.Filters.IndexOf(pivot.GroupingBar.Filters.FirstOrDefault(x => x.Name == "Country"));
                            if (index >= 0)
                            {
                                pivot.ShowSubTotals = true;
                                pivot.GroupingBar.Filters[index].ShowSubTotal = true;
                                count--;
                            }
                        }
                        index = pivot.PivotColumns.IndexOf(pivot.PivotColumns.FirstOrDefault(x => x.FieldMappingName == "Country"));
                        if (index >= 0)
                        {
                            pivot.ShowSubTotals = true;
                            pivot.PivotColumns[index].ShowSubTotal = true;
                            count--;
                        }
                        else
                        {
                            index = pivot.PivotRows.IndexOf(pivot.PivotRows.FirstOrDefault(x => x.FieldMappingName == "Country"));
                            if (index >= 0)
                            {
                                pivot.ShowSubTotals = true;
                                pivot.PivotRows[index].ShowSubTotal = true;
                                count--;
                            }
                        }
                    }
                    else
                    {
                        index = pivot.PivotColumns.IndexOf(pivot.PivotColumns.FirstOrDefault(x => x.FieldMappingName == "Country"));
                        if (index >= 0)
                        {
                            pivot.PivotColumns[index].ShowSubTotal = false;
                            count++;
                        }
                        else
                        {
                            index = pivot.PivotRows.IndexOf(pivot.PivotRows.FirstOrDefault(x => x.FieldMappingName == "Country"));
                            if (index >= 0)
                            {
                                pivot.PivotRows[index].ShowSubTotal = false;
                                count++;
                            }
                        }
                    }
                    pivot.InvalidateCells();
                    break;
                case "Show Date Subtotals":
                    if (current.IsChecked == true)
                    {
                        if (pivot.PivotCalculations.Any(i => i.FieldName == "Date"))
                        {
                            pivot.ShowSubTotals = true;
                            count--;
                        }
                        if (pivot.GroupingBar.Filters.Any(i => i.Name == "Date"))
                        {
                            index = pivot.GroupingBar.Filters.IndexOf(pivot.GroupingBar.Filters.FirstOrDefault(x => x.Name == "Date"));
                            if (index >= 0)
                            {
                                pivot.ShowSubTotals = true;
                                pivot.GroupingBar.Filters[index].ShowSubTotal = true;
                                count--;
                            }
                        }
                        index = pivot.PivotRows.IndexOf(pivot.PivotRows.FirstOrDefault(x => x.FieldMappingName == "Date"));
                        if (index >= 0)
                        {
                            pivot.ShowSubTotals = true;
                            pivot.PivotRows[index].ShowSubTotal = true;
                            count--;
                        }
                        else
                        {
                            index = pivot.PivotColumns.IndexOf(pivot.PivotColumns.FirstOrDefault(x => x.FieldMappingName == "Date"));
                            if (index >= 0)
                            {
                                pivot.ShowSubTotals = true;
                                pivot.PivotColumns[index].ShowSubTotal = true;
                                count--;
                            }
                        }
                    }
                    else
                    {
                        index = pivot.PivotRows.IndexOf(pivot.PivotRows.FirstOrDefault(x => x.FieldMappingName == "Date"));
                        if (index >= 0)
                        {
                            pivot.PivotRows[index].ShowSubTotal = false;
                            count++;
                        }
                        else
                        {
                            index = pivot.PivotColumns.IndexOf(pivot.PivotColumns.FirstOrDefault(x => x.FieldMappingName == "Date"));
                            if (index >= 0)
                            {
                                pivot.PivotColumns[index].ShowSubTotal = false;
                                count++;
                            }
                        }
                    }
                    pivot.InvalidateCells();
                    break;
                case "Show State Subtotals":
                    if (current.IsChecked == true)
                    {
                        if (pivot.PivotCalculations.Any(i => i.FieldName == "State"))
                        {
                            pivot.ShowSubTotals = true;
                            count--;
                        }
                        if (pivot.GroupingBar.Filters.Any(i => i.Name == "State"))
                        {
                            index = pivot.GroupingBar.Filters.IndexOf(pivot.GroupingBar.Filters.FirstOrDefault(x => x.Name == "State"));
                            if (index >= 0)
                            {
                                pivot.ShowSubTotals = true;
                                pivot.GroupingBar.Filters[index].ShowSubTotal = true;
                                count--;
                            }
                        }
                        index = pivot.PivotColumns.IndexOf(pivot.PivotColumns.FirstOrDefault(x => x.FieldMappingName == "State"));
                        if (index >= 0)
                        {
                            pivot.ShowSubTotals = true;
                            pivot.PivotColumns[index].ShowSubTotal = true;
                            count--;
                        }
                        else
                        {
                            index = pivot.PivotRows.IndexOf(pivot.PivotRows.FirstOrDefault(x => x.FieldMappingName == "State"));
                            if (index >= 0)
                            {
                                pivot.ShowSubTotals = true;
                                pivot.PivotRows[index].ShowSubTotal = true;
                                count--;
                            }
                        }
                    }
                    else
                    {
                        index = pivot.PivotColumns.IndexOf(pivot.PivotColumns.FirstOrDefault(x => x.FieldMappingName == "State"));
                        if (index >= 0)
                        {
                            pivot.PivotColumns[index].ShowSubTotal = false;
                            count++;
                        }
                        else
                        {
                            index = pivot.PivotRows.IndexOf(pivot.PivotRows.FirstOrDefault(x => x.FieldMappingName == "State"));
                            if (index >= 0)
                            {
                                pivot.PivotRows[index].ShowSubTotal = false;
                                count++;
                            }
                        }
                    }
                    pivot.InvalidateCells();

                    break;
                case "Show Row Subtotals":
                    if (current.IsChecked == true)
                    {
                        pivot.ShowRowSubTotals = true;
                        showProductSubTotals.IsChecked = true;
                        showDateSubTotals.IsChecked = true;
                        for (int i = 0; i < pivot.PivotRows.Count; i++)
                            pivot.PivotRows[i].ShowSubTotal = true;
                        count = 0;
                    }
                    else
                    {
                        pivot.ShowRowSubTotals = false;
                        showProductSubTotals.IsChecked = false;
                        showDateSubTotals.IsChecked = false;
                    }
                    break;
                case "Show Column Subtotals":
                    if (current.IsChecked == true)
                    {
                        pivot.ShowColumnSubTotals = true;
                        showCountrySubTotals.IsChecked = true;
                        showStateSubTotals.IsChecked = true;
                        for (int i = 0; i < pivot.PivotColumns.Count; i++)
                            pivot.PivotColumns[i].ShowSubTotal = true;
                        count = 0;
                    }
                    else
                    {
                        pivot.ShowColumnSubTotals = false;
                        showCountrySubTotals.IsChecked = false;
                        showStateSubTotals.IsChecked = false;
                    }
                    break;
                case "Show Subtotals":
                    if (current.IsChecked == true)
                    {
                        pivot.ShowSubTotals = true;
                        showProductSubTotals.IsChecked = true;
                        showCountrySubTotals.IsChecked = true;
                        showDateSubTotals.IsChecked = true;
                        showStateSubTotals.IsChecked = true;
                        showRowSubTotals.IsChecked = true;
                        showColumnSubTotals.IsChecked = true;
                        for (int i = 0; i < pivot.PivotRows.Count; i++)
                            pivot.PivotRows[i].ShowSubTotal = true;
                        for (int i = 0; i < pivot.PivotColumns.Count; i++)
                            pivot.PivotColumns[i].ShowSubTotal = true;
                   
                        count = 0;
                    }
                    else
                    {
                        pivot.ShowSubTotals = false;
                        showProductSubTotals.IsChecked = false;
                        showCountrySubTotals.IsChecked = false;
                        showDateSubTotals.IsChecked = false;
                        showStateSubTotals.IsChecked = false;
                        showRowSubTotals.IsChecked = false;
                        showColumnSubTotals.IsChecked = false;
                        for (int i = 0; i < pivot.PivotRows.Count; i++)
                            pivot.PivotRows[i].ShowSubTotal = false;
                        for (int i = 0; i < pivot.PivotColumns.Count; i++)
                            pivot.PivotColumns[i].ShowSubTotal = false;
                   
                        count = 4;
                    }
                    pivot.InvalidateCells();
                    break;
                case "Show Expander for Single Pivot":
                    if (current.IsChecked == true)
                    {
                        pivot.ShowExpanderForSinglePivot = true;
                    }
                    else
                    {
                        pivot.ShowExpanderForSinglePivot = false;
                    }

                    pivot.InvalidateCells();
                    break;
            }
            if (count == 0)
                showAllSubTotals.IsChecked = true;
            else if (count < 4)
                showAllSubTotals.IsChecked = null;
            else if (count == 4)
                showAllSubTotals.IsChecked = false;
        }
    }
}
