﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.ServiceModel.Web;
using System.Text;
using System.Web;

namespace DateTimeDemo
{

    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "ExportService" in code, svc and config file together.
    //[AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Required)]
    public class ExportService : IExportService
    {
        public bool SaveFile(ExportFile exportFile)
        {
            FileStream fileStream = null;
            BinaryWriter writer = null;
            string filePath;

            try
            {
                filePath = HttpContext.Current.Server.MapPath(".") + "\\" + exportFile.FileName;

                if (exportFile.FileName != string.Empty)
                {
                    fileStream = File.Open(filePath, FileMode.Create);
                    writer = new BinaryWriter(fileStream);
                    writer.Write(exportFile.FileStream);
                }

                return true;
            }
            catch (Exception)
            {
                return false;
            }
            finally
            {
                if (fileStream != null)
                    fileStream.Close();
                if (writer != null)
                    writer.Close();
            }
        }

        public void DoWork()
        {
            Console.WriteLine("Yes. Service was here!");
        }
    }

    [DataContract]
    public class ExportFile
    {
        [DataMember]
        public string FileName { get; set; }

        [DataMember]
        public byte[] FileStream { get; set; }
    }
}
