#region Copyright Syncfusion Inc. 2001 - 2017
// Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion

namespace PivotGridCustomization
{
    using Syncfusion.PivotAnalysis.Base;
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Globalization;
    using System.IO;
    using System.Windows;

    public partial class MainWindow : Window
    {
        private readonly string _dateFormat = CultureInfo.CurrentCulture.DateTimeFormat.ShortDatePattern;

        public MainWindow()
        {
            InitializeComponent();
            //pivotGrid1.PivotColumns[1].Comparer = new MonthComparer(pivotGrid1.PivotColumns[1].Format);
            //pivotGrid1.PivotColumns.Add(new PivotItem() { FieldMappingName = "ExpiryDate", FieldHeader = "ExpiryDate", Format = _dateFormat, Comparer = new DateAscendingOrderComparer() });
        }

        private void ExportToClient_Click(object sender, RoutedEventArgs e)
        {

            //using (MemoryStream stream = new MemoryStream())
            //{
            //    ExportServiceClient clientProxy = new ExportServiceClient();
            //    GridExcelExport exportToXls = new GridExcelExport(pivotGrid1, Syncfusion.XlsIO.ExcelVersion.Excel2007, ExportModes.Cell);
            //    exportToXls.Export("SampleXL.xlsx");
            //    using (FileStream fs = File.OpenRead("SampleXL.xlsx"))
            //    {
            //        fs.CopyTo(stream);
            //    }
            //    byte[] bytes = new byte[stream.Length];
            //    stream.Position = 0;
            //    stream.Read(bytes, 0, (int)stream.Length);
            //    clientProxy.SaveFileAsync(new ExportFile { FileName = "SampleXL.xlsx", FileStream = bytes });
            //    //clientProxy.SaveFileCompleted += new EventHandler<SaveFileCompletedEventArgs>(clientProxy_SaveFileCompleted);
            //    stream.Close();
            //}
        }

        
    }

    public class DateAscendingOrderComparer : IComparer
    {
        public int Compare(object x, object y)
        {
            DateTime t1 = x != null ? Convert.ToDateTime(x.ToString()) : DateTime.MinValue;
            DateTime t2 = y != null ? Convert.ToDateTime(y.ToString()) : DateTime.MinValue;

            return t1.CompareTo(t2);
        }
    }
    public class MonthComparer : IComparer
    {
        Dictionary<string, int> lookUp = null;
        string fmt = string.Empty;
        public MonthComparer(string format)
        {
            this.fmt = string.Format("{{0:{0}}}", format);
            this.lookUp = new Dictionary<string, int>();
            DateTime dt0 = DateTime.Now;
            for (int i = 1; i <= 12; ++i)
            {
                DateTime dt = dt0.AddMonths(i - dt0.Month);
                this.lookUp.Add(string.Format(this.fmt, dt), i);
            }
        }


        public int Compare(object x, object y)
        {
            DateTime x1, y1;
            if (DateTime.TryParse(x.ToString(), out x1) && DateTime.TryParse(y.ToString(), out y1))
            {
                x = string.Format(this.fmt, x1);
                y = string.Format(this.fmt, y1);
            }

            return this.lookUp[x.ToString()].CompareTo(this.lookUp[y.ToString()]);
        }
    }
   
}

